
import socket
from time import time

from common import *

class CloudClient:
	def __init__(self, timeout=30):
		self.sock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
		self.sock.setsockopt(socket.SOL_SOCKET,socket.SO_BROADCAST,True)
		self.sock.settimeout(timeout/5)
		self.timeout = timeout

	def publishvalue(self,key,value):
		self.sock.sendto(buildpublish(key,value,0),("255.255.255.255",cloudknowledgeport))

	def getvalue(self,key,default=""):
		self.sock.sendto(buildget(key),("255.255.255.255",cloudknowledgeport))
		t_start = time()
		key,value,age = (key,default,1E7)
		while time() - t_start < self.timeout:
			try:
				data = self.sock.recv(1024)
				k,v,a = parsepublish(data)
				if a < age:
					key,value,age = k,v,a
			except socket.timeout:
				pass
		return value

