
class WrongCommand(Exception):
	pass

cloudknowledgeport = 72374

def parsepublish(cmd):
	"Return the published (key,value,age)-tuple"
	if isinstance(cmd,str):
		cmd = cmd.split("#")
	if not isinstance(cmd,list):
		raise AttributeError
	if not cmd[0] == "PUBLISHVALUE":
		raise WrongCommand

	cmd.pop(0)
	keylen = int(cmd[0])
	cmd.pop(0)
	key = ""
	while len(key) < keylen:
		key += cmd[0]
		cmd.pop(0)
	#print "Key is '%s'" % key
	valuelen = int(cmd[0])
	cmd.pop(0)
	value = ""
	while len(value) < valuelen:
		value += cmd[0]
		cmd.pop(0)
	#print "Value is '%s'" % value
	t = int(cmd[0])
	cmd.pop(0)
	#print "Timestamp is '%i'" % t
	#print "Rest of cmd is %s" % str(cmd)
	return (key,value,t)

def parseget(cmd):
	"Return the key that is requested"
	if isinstance(cmd,str):
		cmd = cmd.split("#")
	if not isinstance(cmd,list):
		raise AttributeError
	if not cmd[0] == "GETVALUE":
		raise WrongCommand

	cmd.pop(0)
	keylen = int(cmd[0])
	cmd.pop(0)
	key = ""
	while len(key) < keylen:
		key += cmd[0]
		cmd.pop(0)
	return key

def parsegetkeys(cmd):
	if not cmd.startswith("GETKEYS"):
		raise WrongCommand
	return True
def buildkeysrequest():
	return "GETKEYS"

def buildpublish(key,value,age):
	out = [ "PUBLISHVALUE" ]
	out.append("%i" % len(key))
	out.append(key)
	out.append("%i" % len(value))
	out.append(value)
	out.append("%i" % age)
	return "#".join(out)

def buildget(key):
	out = [ "GETVALUE" ]
	out.append("%i" % len(key))
	out.append(key)
	return "#".join(out)

