
from socket import *
from time import time

from common import *

class CloudServer:
	def __init__(self):
		self.sock = socket(AF_INET,SOCK_DGRAM)
		self.sock.setsockopt(SOL_SOCKET,SO_BROADCAST,True)
		self.sock.bind(("",cloudknowledgeport))

		self.values = { "lastserverstarted": ("%i"%time(),time()) }

		self.stop = False

	def updatevalue(self,key,value,age):
		if not self.values.has_key(key) or age < time() - self.values[key][1]:
			self.values[key] = (value, time())

	def stopServer(self):
		self.stop = True

	def runServer(self):

		self.sock.sendto(buildpublish("lastserverstarted", self.values["lastserverstarted"][0], time() - self.values["lastserverstarted"][1]), ("255.255.255.255",cloudknowledgeport))
		self.sock.sendto(buildkeysrequest(), ("255.255.255.255",cloudknowledgeport))

		while not self.stop:
			data,(address,port) = self.sock.recvfrom(1024)
			print "CloudServer.runServer() received '%s' from '%s:%i'" % (data,address,port)

			try:
				key,value,age = parsepublish(data)
				self.updatevalue(key,value,age)
			except WrongCommand:
				pass
			try:
				key = parseget(data)
				if self.values.has_key(key):
					if port is not cloudknowledgeport:
						self.sock.sendto(buildpublish(key, self.values[key][0], time() - self.values[key][1]), (address,port))
					self.sock.sendto(buildpublish(key, self.values[key][0], time() - self.values[key][1]), ("255.255.255.255",cloudknowledgeport))
			except WrongCommand:
				pass
			try:
				if parsegetkeys(data):
					print "Request for all keys received"
					print " Will publish my values to other servers."
					for k in self.values.keys():
						self.sock.sendto(buildpublish(k, self.values[k][0], time() - self.values[k][1]), ("255.255.255.255",cloudknowledgeport))
			except WrongCommand:
				pass

